library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity spia is
port(
     datain    : in  std_logic_vector(15 downto 0);
     load      : in  std_logic;
     busy      : out std_logic;
      clk      : in  std_logic;
      cs       : out std_logic;
      sck      : out std_logic;
      sdi      : out std_logic);
end spia;

architecture behavioral of spia is
signal data : std_logic_vector(0 to 15) := "0100111111110001";
begin
  process(load,clk)
  variable i,k:integer:=0;
  begin
       if rising_edge(clk) then
              if load='1' then
                 data <= datain;
                 busy <= '1';
                 i := 0;
              end if;
              if i<65 then
                 cs<='0';
                 i := i + 1;
              else
                  cs<='1';
                  busy <= '0';
              end if;
              if i<3 then
                 sck<='0';
                 sdi<=data(k);
              elsif i<5 then
                    sck<='1';
                    sdi<=data(k);
                    k:=k+1;
              elsif i<7 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<9 then
                    sck<='1';
                    sdi<=data(k);
                    k:=k+1;
              elsif i<11 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<13 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<15 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<17 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<19 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<21 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<23 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<25 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<27 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<29 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<31 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<33 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<35 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<37 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<39 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<41 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<43 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<45 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<47 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<49 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<51 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<53 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<55 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<57 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<59 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<61 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              elsif i<63 then
                    sck<='0';
                    sdi<=data(k);
              elsif i<65 then
                    sck<='1';
                    sdi<=data(k);
                    K:=k+1;
              end if;
          end if;
end process;
end behavioral;
-- See more at: https://www.pantechsolutions.net/project-kits/interfacing-spi-dac-with-spartan-6-fpga#sthash.LiBfY5lD.dpuf
